import logging

from gui_qt.Qt import QtWidgets
from gui_qt.lib.codeeditor import EditorWidget


class ConsoleDock(QtWidgets.QDockWidget):
    def __init__(self, parent=None):
        super().__init__(parent=parent)

        self.code = EditorWidget(self)
        self.code.editor.setReadOnly(True)
        self.setWidget(self.code)


class QTextHandler(logging.Handler):
    def __init__(self, parent):
        super().__init__()

        self.console = ConsoleDock(parent)
        self.setFormatter(logging.Formatter('%(asctime)s - %(levelname)s - %(message)s'))

    def emit(self, record):
        msg = self.format(record)
        self.console.code.appendPlainText(msg)

if __name__ == "__main__":
    app = QtWidgets.QApplication([])
    w = ConsoleDock()
    w.show()

    app.exec()
